#!/bin/sh
export MDFN=/tmp/metadata$$.txt
{ test "$1" = \-&&{ cat /dev/stdin;test x;}||args "$@";}|
while read -er a;do
#a=' '$a
#echo -n $'\t'"$(basename "$FILE")"
bn=$(basename "$a")
>$MDFN
= -n|avconv -i "$a" -f ffmetadata -y $MDFN -loglevel quiet

if test "$meta_mv_tag"&&test "$1" = \-;then
test "$meta_mv_tag_delim"||meta_mv_tag_delim='=';delim=$meta_mv_tag_delim
= -n|args "$@"|tail -n+2|{
need=;av=
while read -er a2;do
test $(= "$a2"|grep -o -e "$delim"|grep -c .) -eq 2||continue
name=$(= "$a2"|cut -f1 -d"$delim"|dn)
value=$(= "$a2"|cut -f2 -d"$delim"|dn) #blank matches all
value2=$(= "$a2"|cut -f3 -d"$delim"|dn) #blank removes name
tag=$(grep $MDFN -ie ^"$name"=|cut -f2- -d\=|dn)
if test ! "$value"||test "$tag" = "$value";then
if test "$tag" != "$value2";then
need=x;av=$av" $(( = =-metadata|cut -c2-;= ="${name}=${value2}"|cut -c2-;)|args)"
fi;fi
done;if test "$need";then
tmpname=./tmp$$.${bn##*.}
= -n|eval 'ffmpeg -i "$a" -movflags use_metadata_tags -acodec copy -vcodec copy'"$av"' -map 0 -disposition:v original -y "$tmpname"'
if test $? -eq 0;then
mv -f "$tmpname" -T "$a"
>$MDFN
= -n|avconv -i "$a" -f ffmetadata -y $MDFN -loglevel quiet;fi
fi;};fi

tag_artist=$(grep $MDFN -ie ^artist=|cut -f2- -d\=)
tag_album=$(grep $MDFN -ie ^album=|cut -f2- -d\=)
tag_album_artist=$(grep $MDFN -ie ^album_artist=|cut -f2- -d\=)
if test "$(= "$tag_album_artist"|tr -d $' \t\r\n')";then
tag_artist=$tag_album_artist #if tag_album_artist is not blank use that instead of artist
tag_artist_tag=album_artist;else tag_artist_tag=artist
fi
if test ! "$(= "$tag_artist"|tr -d $' \t\r\n')";then
= "$a" blank "$tag_artist/$tag_album"
continue
fi
if test ! "$(= "$tag_artist"|tr -d $' \t\r\n')";then
= "$a" blank "$tag_artist/$tag_album"
continue
fi

if test "$meta_mv_tag2";then
tag_yr=$(grep $MDFN -ie ^date=|cut -f2- -d\=)
tag_album_yr=$(grep $MDFN -ie ^album_date=|cut -f2- -d\=)
if test "$(= "$tag_album_yr"|tr -d $' \t\r\n')";then
tag_yr=$tag_album_yr #if tag_album_yr is not blank use that instead of date
tag_yr_tag=album_date;else tag_yr_tag=date
fi
if test "$(= "$tag_album"|tr -d $' \t\r\n')";then
if test "$(= "$tag_yr"|tr -d $' \t\r\n')";then
var1=$(= $[tag_yr-30]|rcut -c1-2)
if test "$(= "$tag_album"|cut -c1-2)" != "$var1";then
if test "$(= "$tag_album"|cut -c1-2|tr -d $'\n'|tr '0123456789.' '..........x')" = '..';then
tag_album=$(= "$tag_album"|cut -c3-|tr -d $'\n')
fi
tag_album=$({ = -n "$var1";= -n "$tag_album";})
#tmpname=$(dirname "$a")/tmp$$.${bn##*.}
tmpname=./tmp$$.${bn##*.}
= -n|ffmpeg -i "$a" -movflags use_metadata_tags -acodec copy -vcodec copy -metadata "album=$tag_album" -map 0 -disposition:v original -y "$tmpname"
if test $? -eq 0;then
mv -f "$tmpname" -T "$a";fi
fi;fi;fi;fi

if test "$meta_mv_tag1";then
if test "$(= "$tag_artist"|cut -c1-2|tr -d $'\n'|tr '0123456789.' '..........x')" = '..';then
tag_artist=$(= "$tag_artist"|cut -c3-|tr -d $'\n')
tmpname=./tmp$$.${bn##*.}
= -n|ffmpeg -i "$a" -movflags use_metadata_tags -acodec copy -vcodec copy -metadata "$tag_artist_tag=$tag_artist" -map 0 -disposition:v original -y "$tmpname"
if test $? -eq 0;then
mv -f "$tmpname" -T "$a";fi
fi;fi
lim1=40;maxlim=max$lim1
tag_artist=$(namefilt filename $maxlim "$tag_artist")
tag_album=$(namefilt filename $maxlim "$tag_album")
if test "$meta_mv_ren";then
tag_disc=$(grep $MDFN -ie ^disc=|cut -f2- -d\=)
tag_track=$(grep $MDFN -ie ^track=|cut -f2- -d\=)
tag_title=$(grep $MDFN -ie ^title=|cut -f2- -d\=)
ext=${bn##*.};fn=${bn%.*};bn2=.$ext
if test ! "$(= "$tag_track"|tr -d $' \t\r\n')"
then bn=$fn;else
test "$(= "$tag_disc"|tr -d $' \t\r\n')"&&tag_track=${tag_disc}-${tag_track}
if test ! "$(= "$tag_title"|tr -d $' \t\r\n')"
then bn="$tag_track $fn"
else bn="$tag_track $tag_title";fi;fi
len_bn2=$(= -n "$bn2"|grep -o .|grep -c .)
test $len_bn2 -gt $lim1&&lim2=0||lim2=$[lim1-len_bn2]
bn=$(namefilt filename $maxlim "$(namefilt filename max$lim2 "$bn")$bn2")
fi
if test ! -e "./$tag_artist/$tag_album/$bn";then
mkdir -p "./$tag_artist/$tag_album"
if test "$meta_mv_ren";then
mv "$a" -T "./$tag_artist/$tag_album/$bn";else
mv "$a" -t "./$tag_artist/$tag_album";fi
else
= "$a" target "./$tag_artist/$tag_album/$bn" existed
fi
done
rm $MDFN

#to undo:
# find -type f|while read -er a;do mv "$a" -t ../dirname;done
# find -mindepth 1 -type d|tac|while read -er a;do rmdir "$a";done