#!/bin/sh
. popterm
#had to add &>/dev/null to avconv, and not pipe python to more, to prevent freeze of X, why?
set +f #glob
for FILE in "$@"
do echo -n $'\t'"$(basename "$FILE")"
avconv -i "$FILE" -f ffmetadata -y /tmp/metadata.txt -loglevel quiet &>/dev/null
cat /tmp/metadata.txt
if test -f /usr/share/pyshared/mutagen-1.20.egg-info
then rm -f /tmp/thumb.png /tmp/lyric*
echo 'from mutagen import File
file = File("'"$FILE"'") # mutagen can automatically detect format and type of tags
artwork = ""

if hasattr(file,"tags"):
 #print file.tags.__dict__.keys()
 #print file.tags._DictProxy__dict.keys()
 import re

 tag=[x for x in file.tags._DictProxy__dict.keys() if (re.search("COMM:.*", x) and not re.search("COMM:iTun.*:.*", x))]
 for x in tag: print "comment",file.tags[x]

 tag=[x for x in file.tags._DictProxy__dict.keys() if re.search("USLT:.*", x)]
 if(len(tag)):
  i=0
  for x in tag:
   fo=open("/tmp/lyric"+str(i),"wb");fo.write(str(file.tags[x]));fo.close()

 if "APIC:" in file.tags:
  artwork = file.tags["APIC:"].data
 else:
  if "APIC:cover" in file.tags:
   artwork = file.tags["APIC:cover"].data
  else:
   if "covr" in file.tags:
    #print file.tags["covr"][0].imageformat
    #jpg works in place of png
    artwork = file.tags["covr"][0]
   #else:
    #import re
    #tag=[x for i, x in enumerate(file.tags) if re.search(".*cover.*", x)]
    #if len(tag)!=0:
    # artwork = file.tags[tag[0]].data
   #else:
    #print file.tags

if artwork!="":
 with open("/tmp/thumb.png", "wb") as img:
   img.write(artwork)
'|python #|more
test -f /tmp/lyric0&&leafpad /tmp/lyric* &
test -f /tmp/thumb.png&&defaultimageviewer /tmp/thumb.png &
fi
done